package exceptions;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Cadre extends JFrame {
  JPanel contentPane;
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel panneauSaisie = new JPanel();
  JTextField saisieX = new JTextField();
  JLabel labelX = new JLabel();
  JLabel nomY = new JLabel();
  JTextField saisieY = new JTextField();
  JLabel labelTaille = new JLabel();
  JTextField saisieTaille = new JTextField();
  JPanel panneauPrincipal = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel panneauBoutons = new JPanel();
  JRadioButton boutonCercle = new JRadioButton();
  JRadioButton boutonCarr = new JRadioButton();
  ButtonGroup groupeBoutons = new ButtonGroup();
  Panneau panneauGraphique = new Panneau();

  /**Construire le cadre*/
  public Cadre() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Initialiser le composant*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Cadre.class.getResource("[Votre icne]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(300, 250));
    this.setTitle("Test sur les exceptions");
    statusBar.setFont(new java.awt.Font("Dialog", 1, 12));
    statusBar.setForeground(Color.red);
    statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
    statusBar.setText(" ");
    saisieX.setText("50");
    saisieX.setColumns(3);
    saisieX.setHorizontalAlignment(SwingConstants.TRAILING);
    saisieX.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saisieX_actionPerformed(e);
      }
    });
    labelX.setFont(new java.awt.Font("Dialog", 1, 12));
    labelX.setLabelFor(saisieX);
    labelX.setText("X");
    nomY.setFont(new java.awt.Font("Dialog", 1, 12));
    nomY.setPreferredSize(new Dimension(30, 17));
    nomY.setHorizontalAlignment(SwingConstants.TRAILING);
    nomY.setLabelFor(saisieY);
    nomY.setText("Y ");
    saisieY.setText("50");
    saisieY.setColumns(3);
    saisieY.setHorizontalAlignment(SwingConstants.TRAILING);
    saisieY.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saisieY_actionPerformed(e);
      }
    });
    labelTaille.setFont(new java.awt.Font("Dialog", 1, 12));
    labelTaille.setMaximumSize(new Dimension(107, 17));
    labelTaille.setPreferredSize(new Dimension(47, 17));
    labelTaille.setHorizontalAlignment(SwingConstants.RIGHT);
    labelTaille.setLabelFor(saisieTaille);
    labelTaille.setText("taille");
    saisieTaille.setText("100");
    saisieTaille.setColumns(4);
    saisieTaille.setHorizontalAlignment(SwingConstants.TRAILING);
    saisieTaille.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saisieTaille_actionPerformed(e);
      }
    });
    panneauPrincipal.setLayout(borderLayout2);
    boutonCercle.setFont(new java.awt.Font("Dialog", 1, 12));
    boutonCercle.setPreferredSize(new Dimension(72, 25));
    boutonCercle.setHorizontalAlignment(SwingConstants.CENTER);
    boutonCercle.setSelected(true);
    boutonCercle.setText("Cercle");
    boutonCercle.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boutonCercle_actionPerformed(e);
      }
    });
    boutonCarr.setFont(new java.awt.Font("Dialog", 1, 12));
    boutonCarr.setPreferredSize(new Dimension(72, 25));
    boutonCarr.setHorizontalAlignment(SwingConstants.CENTER);
    boutonCarr.setText("Carr");
    boutonCarr.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boutonCarr_actionPerformed(e);
      }
    });
    panneauGraphique.setBackground(Color.orange);
    panneauGraphique.setForeground(SystemColor.desktop);
    panneauGraphique.setLayout(null);
    contentPane.add(statusBar,  BorderLayout.SOUTH);
    contentPane.add(panneauSaisie, BorderLayout.NORTH);
    panneauSaisie.add(labelX, null);
    panneauSaisie.add(saisieX, null);
    panneauSaisie.add(nomY, null);
    panneauSaisie.add(saisieY, null);
    panneauSaisie.add(labelTaille, null);
    panneauSaisie.add(saisieTaille, null);
    contentPane.add(panneauPrincipal, BorderLayout.CENTER);
    panneauPrincipal.add(panneauBoutons, BorderLayout.SOUTH);
    panneauBoutons.add(boutonCercle, null);
    panneauBoutons.add(boutonCarr, null);
    panneauPrincipal.add(panneauGraphique, BorderLayout.CENTER);
    groupeBoutons.add(boutonCercle);
    groupeBoutons.add(boutonCarr);
  }
  /**Remplac, ainsi nous pouvons sortir quand la fentre est ferme*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void saisieX_actionPerformed(ActionEvent e) {
    try {
      panneauGraphique.setXForme(Integer.parseInt(saisieX.getText()));
      statusBar.setText(" ");
    }
    catch (ErreurForme erreur) {
      statusBar.setText(erreur.getMessage());
      saisieX.setText(String.valueOf(panneauGraphique.getXForme()));
    }
  }

  void saisieY_actionPerformed(ActionEvent e) {
    try {
      panneauGraphique.setYForme(Integer.parseInt(saisieY.getText()));
      statusBar.setText(" ");
    }
    catch (ErreurForme erreur) {
      statusBar.setText(erreur.getMessage());
      saisieY.setText(String.valueOf(panneauGraphique.getYForme()));
    }
  }

  void saisieTaille_actionPerformed(ActionEvent e) {
    try {
      panneauGraphique.setDimensionForme(Integer.parseInt(saisieTaille.getText()));
      statusBar.setText(" ");
    }
    catch (ErreurForme erreur) {
      statusBar.setText(erreur.getMessage());
      saisieTaille.setText(String.valueOf(panneauGraphique.getDimensionForme()));
    }
  }

  void boutonCercle_actionPerformed(ActionEvent e) {
    panneauGraphique.setForme(Cercle.class);
  }

  void boutonCarr_actionPerformed(ActionEvent e) {
    panneauGraphique.setForme(Carr.class);
  }
}